/*
*/
#include <unistd.h>
#include "str.h"
#include "fmt.h"
#include "buffer.h"
#include "errmsg.h"
#include "qstrings.h"

#define qputs(s) buffer_puts(buffer_1,(s))
#define qputf(s) qputs(s),buffer_putsflush(buffer_1,"\n")

#define WHO "strtest"

int main() {
  ssize_t r;
  char s[128];
  char *x;

  x = "bla-";

#define PASS "\033[32mOK\033[0m"
#define FAIL "\033[91mFAILED\033[0m"
//qputf(x);
  buffer_puts(buffer_1,"Checking function 'str_cats' ... ");
  r = str_cats(&x,"blubb");
  if (r == 9) qputf(PASS);
  else qputf(FAIL);

  buffer_puts(buffer_1,"Checking function 'str_copys' ... ");
  r = str_copys(&x,"blubb");
  if (r == 5) buffer_puts(buffer_1,PASS);
  else buffer_puts(buffer_1,FAIL);

  buffer_putsflush(buffer_1,"\n");
//qputf(x);

  /* show the behavior of 'str_copy' **************************************** */
  buffer_puts(buffer_1,"Checking function 'str_copy' ... ");
  byte_zero(s,str_len(s));         /* reset the string s (empty) */
  r = str_copy(s," mystring");
  if (r == 9) buffer_puts(buffer_1,PASS);
  else buffer_puts(buffer_1,FAIL);
  buffer_putsflush(buffer_1,"\n");

  /* test str_len *********************************************************** */
  buffer_puts(buffer_1,"Checking function 'str_len' ... ");
  byte_zero(s,str_len(s));         /* reset the string s (empty) */
  str_copy(s,"teststring");
  r = str_len(s);
  if (r == 10) buffer_puts(buffer_1,PASS);
  else buffer_puts(buffer_1,FAIL);
  buffer_putsflush(buffer_1,"\n");

  /* test str_rchr: search for a byte *************************************** */
  buffer_puts(buffer_1,"Checking function 'str_chr' ... ");
  r = str_chr(s,'s');    /* expected index 2 (= position 3) */
  if (r == 2) buffer_puts(buffer_1,PASS);
  else buffer_puts(buffer_1,FAIL);
  buffer_putsflush(buffer_1,"\n");

  /* test str_rchr ********************************************************** */
  buffer_puts(buffer_1,"Checking function 'str_rchr' ... ");
  r = str_rchr(s,'s');    /* expected index 4 (pos. 5) */
  if (r == 4) buffer_puts(buffer_1,PASS);
  else buffer_puts(buffer_1,FAIL);
  buffer_putsflush(buffer_1,"\n");

  /* tests str_diff ********************************************************* */
  buffer_puts(buffer_1,"Checking function 'str_diff' ... ");
  x = "abcd";
  byte_zero(s,str_len(s));         /* reset the string s (empty) */
  str_copy(s,x);
  r = str_diff(s,x);	/* the strings are equal (expected result. 0) */
  if (r == 0) {
    x = "abcf";			/* d is 2 chars smaller than f (expected result: -2) */
    r = str_diff(s,x);
	if (r == -2) {
	  x = "abcc";       /* d is one char bigger than c (expected result: 1) */
  	  r = str_diff(s,x);
//buffer_putsflush(buffer_1,fmtnum(r));
	  if (r == 1) buffer_puts(buffer_1,PASS);
	  else buffer_puts(buffer_1,FAIL);
	}
	else buffer_puts(buffer_1,FAIL);
  }
  else buffer_puts(buffer_1,FAIL);
  buffer_putsflush(buffer_1,"\n");

  /* tests str_diffn ******************************************************** */
  buffer_puts(buffer_1,"Checking function 'str_diffn' ... ");
  r = str_diffn(s,x,3);
  if (r == 0) {
	r = str_diffn(s,x,4);		/* expected 1 */
	if (r == 1) {
	  x = "accd";
	  r = str_diffn(s,x,4);
	  if (r == -1 ) buffer_puts(buffer_1,PASS);
	  else buffer_puts(buffer_1,FAIL);
	}
	else buffer_puts(buffer_1,FAIL);
  }
  else buffer_puts(buffer_1,FAIL);
  buffer_putsflush(buffer_1,"\n");

  /* test str_pcmp (compare prefixes) *************************************** */
  buffer_puts(buffer_1,"Checking function 'str_pcmp' ... ");
  r = str_pcmp(s,"abc");
  if (r == 1) {
	r = str_pcmp(s,"cba");
	if (r == 0) buffer_puts(buffer_1,PASS);
	else buffer_puts(buffer_1,FAIL);
  }
  else buffer_puts(buffer_1,FAIL);
  buffer_putsflush(buffer_1,"\n");

  /* test str_equal ********************************************************* */
  buffer_puts(buffer_1,"Checking function 'str_equal' ... ");
  r = str_equal(s,"abcd");
  if (r == 1) {
	r = str_equal(s,"aaaa");
	if (r == 0) buffer_puts(buffer_1,PASS);
    else buffer_puts(buffer_1,FAIL);
  }
  else buffer_puts(buffer_1,FAIL);
  buffer_putsflush(buffer_1,"\n");

//  errmsg("",-100,3,"");
  _exit(0);
}
